ORG 0000H
jmp start
led equ p3.7

Message5:
db 'AT+IPR=9600',13,0
Message0:
db 'ATE0',13,0
Message1:
db 'AT',13,0
Message2:
db 'AT+CMGF=1',13,0
Message3:
db 'AT+CNMI=2,1,0,0,0',13,0
Message4:
db 'AT+CMGR=2',13,0
message6:
db 'AT+CMGD=2',13,0
	
BUFFERLIMIT equ 16H	
 BUFFERLIMIT2 equ 31H
byteCount equ 20h
bufferIn equ 	21h  //store incoming text

start:	 clr p3.7

acall serial_Init  
acall lcd_init
mov byteCount,#0 																																				  
MOV r0,#bufferIn    //buffer for messages
  //start mobile
		  	mov dptr,#Message1 ;address first message
	acall serial_print_string  //send message
	ACALL DELAY1

  	mov dptr,#Message0  ;address first message
	acall serial_print_string  //send message
	ACALL DELAY1
	mov dptr,#Message5  ;address first message
	acall serial_print_string  //send message
	ACALL DELAY1
	mov dptr,#Message2  ;address first message
	acall serial_print_string  //send message
	ACALL DELAY1
	mov dptr,#Message3  ;address first message
	acall serial_print_string  //send message
	ACALL DELAY1
up:	clr p3.7
   acall delay
   mov dptr,#Message4  ;address first message
	acall serial_print_string  //send message
	//Wait for serial input ending 'X'
	acall DELAY1
	MOV r0,#bufferIn 

	
H1: JNB RI,H1  //wait for char
	CLR RI
	MOV A,SBUF  //get and store in buffer
	MOV @R0,A
	mov A,byteCount
	CJNE A,#BUFFERLIMIT,roomleft  //check we have room on 1st line
	
	mov A,#0C0h
	acall comnwrt
	acall delay
	mov a, byteCount
	CJNE A,#BUFFERLIMIT2,roomleft //check for eo nd line	
	MOV @R0,#'X' //terminate string
	jmp DISPLAY  //print what we have
	
roomleft:
     MOV A,@R0  //recover char
    inc byteCount
	INC R0
	CJNE A,#'X',H1  //wait for X to end message
	//setb p3.7
	 	  mov dptr,#Message6
	acall serial_print_string
DISPLAY:   mov a,#01H
	acall  comnwrt	

//mov dptr,#Message4
//	acall serial_print_string

       MOV r0,#bufferIn    //back to start
dis:
       MOV A,@R0
	  

      cjne A,#'X',H
	  setb p3.7
	   acall delay
	   clr p3.7
	 ACALL DELAY1
	 ACALL DELAY1
	         
	MOV A,#"A"
ACALL SEND 
MOV A,#"T"
ACALL SEND 
MOV A,#"+"
ACALL SEND
MOV A,#"C"
ACALL SEND
MOV A,#"M"
ACALL SEND
MOV A,#"G"
ACALL SEND
MOV A,#"D"
ACALL SEND
MOV A,#"="
ACALL SEND
MOV A,#"2"
ACALL SEND
MOV A,#0DH
ACALL SEND

	sjmp up
				  
	  
	  
wait:  SETB P0.0
       sjmp wait  //stop at X
H:	 
acall delay
       acall datawrt
	   acall delay
       inc r0
       sjmp   dis //next char


comnwrt:mov P1,a
        clr P2.0;  For command
		clr P2.1   ;for  write
		setb P2.2	; E=1  for high pulse
		acall delay
		clr P2.2 ;H-to-L pulse
		ret

datawrt:mov P1,a
		setb P2.0	;for data
		clr P2.1	;for write
		setb P2.2	  ;E=1 for high pulse
		acall delay
		clr p2.2	 ; H-to-L pulse
		ret
delay: mov R3,#50
here2:mov R4,#255
here:djnz R4,here
		djnz R3,Here2
		ret




SEND:
     JNB TI,SEND
     CLR TI//clear  flag
	 MOV SBUF,A
     RET
	 
	 
DELAY1:MOV R6,#15
BACK:MOV TH0,#00000000B
     MOV TL0,#00000000B
	 SETB TR0
HERE1:JNB TF0,HERE1
     CLR TR0
	 CLR TF0
	 DJNZ R6,BACK
	 RET
	 
	 
	 
	 
serial_print_string:	 //dptr points to 0 terminated string

     mov A,#0
     movc A,@A+dptr ;get a char	
	 	 cjne A,#0,sendchar	 	 //stop at 0
	 ret
sendchar:	 
	 acall SEND
	 inc dptr    
	 jmp serial_print_string
	 
	 
	 
Serial_Init:
	;Set timer 1 mode to 8-bit Auto-Reload
	mov TMOD,#20H
	;Enable reception
	;Set Serial port mode to 8-bit UART
	mov SCON,#50H
	;Set baudrate to 9600 at 11.0592MHz
	mov TH1,#0FDH
	mov TL1,#0FDH
	;Start Timer
	setb TR1
	CLR RI  //clear recieved flag
	setb TI //set all sent	
	ret
	 
	
	
	
lcd_init:	
mov A,#38h
acall comnwrt
acall delay
mov a,#0eh
acall comnwrt
acall delay
mov a,#01h
acall comnwrt
acall delay
mov a,#06h
acall comnwrt
acall delay
 mov a,#80h
acall comnwrt
mov a,#8Fh
acall comnwrt
MOV A,#14H
acall comnwrt
acall delay


mov a,#01h
acall comnwrt
ret



	end